# capi-user-awareness
User Awareness Framework CAPI

# Test Environment(demo#1 version)

* TV Board used:
> 1. Nike M2 ATSC [To verify BLE and WiFi Sensors]
> 2. Frame TV (Factory Setting: model name -> LS03R) [To verify Light & Motion Sensors]

* Verified Image Path:
http://repos.vd.sec.samsung.net/products/tv/official/2023/ONEMAIN/NikeM2/latest/images/T-NKM2AKUC/TIZEN-ONEMAIN-NikeM2-RELEASE_20220603.4_T-NKM2AKUC.tar.gz

* TV Image info :
```
sh-3.2# cat /etc/info.ini
[Version]
Model=Tizen6/TV;
Build=latest;
Release=latest;
[Build]
Type=eng;
Date=20220417_165901;
Time=16:59:01;
Variant=NONE;
ID=latest;
 ```

### Preconditions for verifying operations
```
For verifying WiFi operations:
```
1. Connect TV and mobile to same WiFi AP first
```

*Note: We have executed the Light and Motion operations on Frame TV*

**For debugging UA framework logs can be checked with below command:**
```
logger-mgr --filter UA_MANAGER UAM_API UA_CAPI UA_PLUGIN_BLE UA_PLUGIN_LIGHT UA_PLUGIN_WIFI UA_PLUGIN_MOTION UA_PLUGIN_WIFI_LOCATION UA_PLUGIN_UWB
dlogutil -v threadtime UA_MANAGER UAM_API UA_CAPI UA_PLUGIN_BLE UA_PLUGIN_LIGHT UA_PLUGIN_WIFI UA_PLUGIN_MOTION UA_PLUGIN_WIFI_LOCATION UA_PLUGIN_UWB
```` 

# How to test UAFW


## 1. Initialze
```
root:~> ua-test 

* User Awareness test application 
* Build On: May 23 2022  03:56:18

=================================================================
 Main
-----------------------------------------------------------------
 [  1] Init                                                    >
 --------------------------------------------------------------- 
 [ - ] Added Sensor(s) [ ] 
 --------------------------------------------------------------- 
 [ u ] Account / Name [default@default.com / default ] 
 --------------------------------------------------------------- 
 [ s ] Service [ua.service.default ] 
 --------------------------------------------------------------- 
 [ d ] Device [WIFI Android   ] 
 --------------------------------------------------------------- 
 [ p ] Previous menu 
 [ m ] Show Menu 
 [ q ] Quit 
=================================================================

(10890) >> 
=================================================================
 Main >> Init
-----------------------------------------------------------------
 [  1] Init                                                    >
 [  2] Devices                                                 >
 [  3] Users                                                   >
 [  4] Services                                                >
 [  5] Sensors                                                 >
 [  6] Detection                                               >
 [  7] Scenario                                                >
 --------------------------------------------------------------- 
 [ - ] Added Sensor(s) [ ] 
 --------------------------------------------------------------- 
 [ u ] Account / Name [default@default.com / default ] 
 --------------------------------------------------------------- 
 [ s ] Service [ua.service.default ] 
 --------------------------------------------------------------- 
 [ d ] Device [WIFI Android   ] 
 --------------------------------------------------------------- 
 [ p ] Previous menu 
 [ m ] Show Menu 
 [ q ] Quit 
=================================================================
(10890) >> 


(10890) >> 7

=================================================================
 Main >> Init >> Scenario
-----------------------------------------------------------------
 [  1] ua_startup
 [  2] ua_cleanup
 [  3] ua_add_device                                           >
 [  4] ua_foreach
 [ 11] start/stop absence/presence detection                   >
 [ 12] start/stop location detection                           >
 [ 21] ua_loop_init_deinit ()                                  >
 [ 22] ua_loop_startup_cleanup ()                              >
 --------------------------------------------------------------- 
 [ - ] Added Sensor(s) [ ] 
 --------------------------------------------------------------- 
 [ u ] Account / Name [default@default.com / default ] 
 --------------------------------------------------------------- 
 [ s ] Service [ua.service.default ] 
 --------------------------------------------------------------- 
 [ d ] Device [WIFI Android   ] 
 --------------------------------------------------------------- 
 [ p ] Previous menu 
 [ m ] Show Menu 
 [ q ] Quit 
=================================================================
(10890) >> 

( 3881) >> 1
 ### uat_scenario_startup ###
 - ua_initialize() ret: [0xFCF60003] [UA_ERROR_ALREADY_DONE]
ua_service_create
 - ua_service_create() ret: [0x0] [UA_ERROR_NONE]
 - ua_service_add() ret: [0x0] [UA_ERROR_NONE]
 - ua_set_detection_cycle() ret: [0x0] [UA_ERROR_NONE]
ua_user_create
 - ua_user_create() ret: [0x0] [UA_ERROR_NONE]
 - ua_user_add() ret: [0x0] [UA_ERROR_NONE]
 - ua_service_add_user() ret: [0x0] [UA_ERROR_NONE]
ua_monitor_create
 - ua_monitor_create() ret: [0x0] [UA_ERROR_NONE]
 - ua_monitor_add_sensor() ret: [0x0] [UA_ERROR_NONE]
ua_monitor_set_sensor_status_changed_cb
 - ua_monitor_set_sensor_status_changed_cb() ret: [0x0] [UA_ERROR_NONE]
( 3881) >> 

```

## 2. Add Devices (Example: Wi-Fi device, same steps for BLE device as well)

```
( 3881) >> 3

=================================================================
 Main >> Init >> Scenario >> ua_add_device
-----------------------------------------------------------------
 [  1] OS type (1:Tizen 2:Andorid 3:iOS) (2)
 [  2] device_id ()
 [  3] MAC ()
 [  4] IPv4 address ()
 [  5] run
 --------------------------------------------------------------- 
 [ - ] Added Sensor(s) [WIFI  ] 
 --------------------------------------------------------------- 
 [ u ] Account / Name [ua.scenerio.account1 / default ] 
 --------------------------------------------------------------- 
 [ s ] Service [ua.scenerio.service1 ] 
 --------------------------------------------------------------- 
 [ d ] Device [WIFI Android   ] 
 --------------------------------------------------------------- 
 [ p ] Previous menu 
 [ m ] Show Menu 
 [ q ] Quit 
=================================================================
( 3881) >> 


================================================================
 Main >> Init >> Scenario >> ua_add_device
-----------------------------------------------------------------
 [  1] OS type (1:Tizen 2:Andorid 3:iOS) (2)
 [  2] device_id (17:34:98:08:67:12)
 [  3] MAC ()
 [  4] IPv4 address ()
 [  5] run
 --------------------------------------------------------------- 
 [ - ] Added Sensor(s) [WIFI  ] 
 --------------------------------------------------------------- 
 [ u ] Account / Name [ua.scenerio.account1 / default ] 
 --------------------------------------------------------------- 
 [ s ] Service [ua.scenerio.service1 ] 
 --------------------------------------------------------------- 
 [ d ] Device [WIFI Android 17:34:98:08:67:12  ] 
 --------------------------------------------------------------- 
 [ p ] Previous menu 
 [ m ] Show Menu 
 [ q ] Quit 
=================================================================
( 3881) >> 


=================================================================
 Main >> Init >> Scenario >> ua_add_device
-----------------------------------------------------------------
 [  1] OS type (1:Tizen 2:Andorid 3:iOS) (2)
 [  2] device_id (17:34:98:08:67:12)
 [  3] MAC (17:34:98:08:67:12)
 [  4] IPv4 address ()
 [  5] run
 --------------------------------------------------------------- 
 [ - ] Added Sensor(s) [WIFI  ] 
 --------------------------------------------------------------- 
 [ u ] Account / Name [ua.scenerio.account1 / default ] 
 --------------------------------------------------------------- 
 [ s ] Service [ua.scenerio.service1 ] 
 --------------------------------------------------------------- 
 [ d ] Device [WIFI Android 17:34:98:08:67:12 17:34:98:08:67:12 ] 
 --------------------------------------------------------------- 
 [ p ] Previous menu 
 [ m ] Show Menu 
 [ q ] Quit 
=================================================================
( 3881) >> 

=================================================================
 Main >> Init >> Scenario >> ua_add_device
-----------------------------------------------------------------
 [  1] OS type (1:Tizen 2:Andorid 3:iOS) (2)
 [  2] device_id (17:34:98:08:67:12)
 [  3] MAC (17:34:98:08:67:12)
 [  4] IPv4 address ()
 [  5] run
 ---------------------------------------------------------------
 [ - ] Added Sensor(s) [BLE WIFI LIGHT  ]
 ---------------------------------------------------------------
 [ u ] Account / Name [ua.scenerio.account1 / default ]
 ---------------------------------------------------------------
 [ s ] Service [ua.scenerio.service1 ]
 ---------------------------------------------------------------
 [ d ] Device [WIFI Android 17:34:98:08:67:12 17:34:98:08:67:12 ]
 ---------------------------------------------------------------
 [ p ] Previous menu
 [ m ] Show Menu
 [ q ] Quit
=================================================================
( 3756) >> 4

=================================================================
 Input [IPv4 address] data
-----------------------------------------------------------------
 current = []
 new >> 192.168.60.118
OK.

=================================================================
 Main >> Init >> Scenario >> ua_add_device
-----------------------------------------------------------------
 [  1] OS type (1:Tizen 2:Andorid 3:iOS) (2)
 [  2] device_id (17:34:98:08:67:12)
 [  3] MAC (17:34:98:08:67:12)
 [  4] IPv4 address ()
 [  5] run
 ---------------------------------------------------------------
 [ - ] Added Sensor(s) [BLE WIFI LIGHT  ]
 ---------------------------------------------------------------
 [ u ] Account / Name [ua.scenerio.account1 / default ]
 ---------------------------------------------------------------
 [ s ] Service [ua.scenerio.service1 ]
 ---------------------------------------------------------------
 [ d ] Device [WIFI Android 17:34:98:08:67:12 17:34:98:08:67:12 ]
 ---------------------------------------------------------------
 [ p ] Previous menu
 [ m ] Show Menu
 [ q ] Quit
=================================================================
( 3756) >> 5
_
_create_add_device
 - ua_device_create() ret: [0x0] [UA_ERROR_NONE]
 - ua_device_set_os_info() ret: [0x0] [UA_ERROR_NONE]
 - ua_device_set_wifi_ipv4_address() ret: [0x0] [UA_ERROR_NONE]
 - ua_user_add_device() ret: [0x0] [UA_ERROR_NONE]
 - Wi-Fi device add ret: [0x0] [UA_ERROR_NONE]
__create_add_device
 - ua_device_create() ret: [0x0] [UA_ERROR_NONE]
 - ua_device_set_os_info() ret: [0x0] [UA_ERROR_NONE]
 - ua_user_add_device() ret: [0x0] [UA_ERROR_NONE]
 - BLE device add () ret: [0x0] [UA_ERROR_NONE]
__device_added_cb() result: [0x0] [UA_ERROR_NONE]
Device MAC Type : BLE
Device OS Type : Android
Device ID : 17:34:98:08:67:12
Device MAC : 17:34:98:08:67:12
Device IPv4 Addr :
 - ua_device_get_mac_type() ret: [0x0] [UA_ERROR_NONE]
__device_added_cb() result: [0x0] [UA_ERROR_NONE]
Device MAC Type : WIFI
Device OS Type : Android
Device ID : 17:34:98:08:67:12
Device MAC : 17:34:98:08:67:12
Device IPv4 Addr : 192.168.60.118
 - ua_device_get_mac_type() ret: [0x0] [UA_ERROR_NONE
```

## 3. How to check the added device list

```
=================================================================
 Main >> Init >> Scenario >> ua_add_device
-----------------------------------------------------------------
 [  1] OS type (1:Tizen 2:Andorid 3:iOS) (2)
 [  2] device_id (17:34:98:08:67:12)
 [  3] MAC (17:34:98:08:67:12)
 [  4] IPv4 address (192.168.60.118)
 [  5] run
 ---------------------------------------------------------------
 [ - ] Added Sensor(s) [BLE WIFI LIGHT  ]
 ---------------------------------------------------------------
 [ u ] Account / Name [ua.scenerio.account1 / default ]
 ---------------------------------------------------------------
 [ s ] Service [ua.scenerio.service1 ]
 ---------------------------------------------------------------
 [ d ] Device [WIFI Android 17:34:98:08:67:12 17:34:98:08:67:12 ]
 ---------------------------------------------------------------
 [ p ] Previous menu
 [ m ] Show Menu
 [ q ] Quit
=================================================================
( 3756) >> d

=================================================================
 Main >> Init >> Scenario >> ua_add_device >> Select Device
-----------------------------------------------------------------
 [  1] Device list ()
 [  2] Apply
 ---------------------------------------------------------------
 [ - ] Added Sensor(s) [BLE WIFI LIGHT  ]
 ---------------------------------------------------------------
 [ u ] Account / Name [ua.scenerio.account1 / default ]
 ---------------------------------------------------------------
 [ s ] Service [ua.scenerio.service1 ]
 ---------------------------------------------------------------
 [ d ] Device [WIFI Android 17:34:98:08:67:12 17:34:98:08:67:12 ]
 ---------------------------------------------------------------
 [ p ] Previous menu
 [ m ] Show Menu
 [ q ] Quit
=================================================================
( 3756) >> 1
ua_foreach_devices
g_device_list is NULL

[1]
Device MAC Type : WIFI
Device OS Type : Android
Device ID : 17:34:98:08:67:12
Device MAC : 17:34:98:08:67:12
Device BSSID : (null)
Device IPv4 Addr : 192.168.60.118
Pairing Required : NO
Last present at : 240325

[2]
Device MAC Type : BLE
Device OS Type : Android
Device ID : 17:34:98:08:67:12
Device MAC : 17:34:98:08:67:12
Device BSSID : (null)
Device IPv4 Addr :
Pairing Required : NO
Last present at : 117373
 - ua_foreach_devices() ret: [0x0] [UA_ERROR_NONE]
( 3756) >>
=================================================================
```

## 4. Remove device (Following step 3.)
```

=================================================================
 Main >> Init >> Users
-----------------------------------------------------------------
 [  1] ua_user_create                                          >
 [  2] ua_user_destroy
 [  4] ua_user_add
 [  5] ua_user_remove
 [  6] ua_get_default_user
 [  7] ua_service_get_user_by_account                          >
 [  8] ua_foreach_users                                        >
 [ 11] ua_user_add_device
 [ 12] ua_user_remove_device
 [ 14] ua_user_foreach_devices                                 >
 ---------------------------------------------------------------
 [ - ] Added Sensor(s) [BLE WIFI LIGHT  ]
 ---------------------------------------------------------------
 [ u ] Account / Name [ua.scenerio.account1 / default ]
 ---------------------------------------------------------------
 [ s ] Service [ua.scenerio.service1 ]
 ---------------------------------------------------------------
 [ d ] Device [BLE Android 17:34:98:08:67:12 17:34:98:08:67:12 ]
 ---------------------------------------------------------------
 [ p ] Previous menu
 [ m ] Show Menu
 [ q ] Quit
=================================================================
( 3756) >> 12
ua_user_remove_device
 - ua_user_remove_device() ret: [0x0] [UA_ERROR_NONE]
```

## 5. Detect PRESENCE / ABSENCE (Example. Wi-Fi)
```
=================================================================
 Main >> Init >> Scenario
-----------------------------------------------------------------
 [  1] ua_startup
 [  2] ua_cleanup
 [  3] ua_add_device                                           >
 [  4] ua_foreach
 [ 11] start/stop absence/presence detection                   >
 [ 12] start/stop location detection                           >
 [ 21] ua_loop_init_deinit ()                                  >
 [ 22] ua_loop_startup_cleanup ()                              >
 ---------------------------------------------------------------
 [ - ] Added Sensor(s) [BLE WIFI LIGHT  ]
 ---------------------------------------------------------------
 [ u ] Account / Name [ua.scenerio.account1 / default ]
 ---------------------------------------------------------------
 [ s ] Service [ua.scenerio.service1 ]
 ---------------------------------------------------------------
 [ d ] Device [BLE Android 17:34:98:08:67:12 17:34:98:08:67:12 ]
 ---------------------------------------------------------------
 [ p ] Previous menu
 [ m ] Show Menu
 [ q ] Quit
=================================================================
( 3756) >> 11

=================================================================
 Main >> Init >> Scenario >> start/stop absence/presence detection
-----------------------------------------------------------------
 [  1] ABSENCE detection type (1:ALL 2:ANY) (2)
 [  2] PRESENCE detection type (1:ALL 2:ANY) (2)
 [  3] start
 [  4] stop
 ---------------------------------------------------------------
 [ - ] Added Sensor(s) [BLE WIFI LIGHT  ]
 ---------------------------------------------------------------
 [ u ] Account / Name [ua.scenerio.account1 / default ]
 ---------------------------------------------------------------
 [ s ] Service [ua.scenerio.service1 ]
 ---------------------------------------------------------------
 [ d ] Device [BLE Android 17:34:98:08:67:12 17:34:98:08:67:12 ]
 ---------------------------------------------------------------
 [ p ] Previous menu
 [ m ] Show Menu
 [ q ] Quit
=================================================================
( 3756) >> 3
run_ua_monitor_start_detection
 - ua_monitor_start_absence_detection() ret: [0x0] [UA_ERROR_NONE]
 - ua_monitor_start_presence_detection() ret: [0x0] [UA_ERROR_NONE]
( 3756) >>
[1970-01-01 05:39:57]
Absence detected for service [ua.scenerio.service1]
[WIFI] ABSENCE detected [UA_ERROR_NONE]

[1970-01-01 05:39:58]
[LIGHT] Sensor Status Changed -> ABSENCE
[LIGHT] timestamp [598519]
4
run_ua_monitor_stop_detection,
 - ua_monitor_stop_absence_detection() ret: [0x0] [UA_ERROR_NONE]
 - ua_monitor_stop_presence_detection() ret: [0x0] [UA_ERROR_NONE]
( 3756) >>
```

# Trouble shooting
###### 1. If get_default user command fails
- Execute 'get_default_user'
```sh
tc_usage_print:828() Key 21 : usage Get default user) 
```
- OUTPUT
```sh
test_input_callback:499() returns UA_ERROR_NONE
test_input_callback:505() ua_user_get_account returned : UA_ERROR_NONE
test_input_callback:507() User account info default@default.com
```
- Solution 
```sh
STEP 1. remove DB first 
sh-3.2# rm -f /opt/usr/dbspace/.ua-manager-data.db*

STEP 2. re-install ua-manager RPMs

STEP 3. sync & reboot
```
