/*
 * Copyright (c) 2021 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

#ifndef _TCT_COMMON_H_
#define _TCT_COMMON_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "assert_local.h"

#include <malloc.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>

#define DEBUG_GCOV 1
#ifdef DEBUG_GCOV
#define COMMON_DEBUG					1
#else
#define COMMON_DEBUG					0
#endif

#define FREE_MEMORY_TC(buffer) { \
	if (buffer != NULL) { \
		free(buffer); \
		buffer = NULL; \
	} \
}

#define PRINT_LOG(type, tag, ...) do { \
	fprintf(stdout,  ##__VA_ARGS__); \
	fprintf(stdout,  "\n"); \
} while (0)

#ifdef __cplusplus
}
#endif

#endif // _TCT_COMMON_H_
