/*
 * Copyright (c) 2021 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

#ifndef _TESTCASE_H_
#define _TESTCASE_H_

#ifdef __cplusplus
extern "C" {
#endif

/* pointer to startup/cleanup functions */
typedef void (*void_fun_ptr)(void);

/* pointer to testcase functions */
typedef int (*tc_fun_ptr)(void);

/* struct describing specific testcase */
typedef struct testcase_s {
	const char* name;
	tc_fun_ptr function;
	void_fun_ptr startup;
	void_fun_ptr cleanup;
} testcase;

#ifdef __cplusplus
}
#endif
#endif // _TESTCASE_H_
